/*
 * AddDeleteOptions.java
 *
 * Created on 27 January 2002, 17:02
 */

package com.togethersoft.modules.p4vcs.dialogs;

import com.perforce.api.Change;
import com.togethersoft.openapi.ide.window.IdeDialogButtonGroup;
import com.togethersoft.openapi.ide.window.IdeWindowManager;
import com.togethersoft.openapi.ide.window.IdeWindowManagerAccess;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;

/** @author  Administrator */
public class AdvancedOptionsDialog extends JDialog
{
   private boolean isOK = false;
   private boolean autoSubmit = true;
   private int changeNumber = 0;
   private String changeDescription = "";
   private boolean openForDelete = false;

   /** Creates new form AddDeleteOptions */
   public AdvancedOptionsDialog(JDialog parent, boolean modal, Object[] changes, boolean checkOut, boolean checkIn)
   {
      super(parent, modal);
      this.changeNumbers = new DefaultComboBoxModel(changes);
      initComponents();
      if (checkOut)
      {
         deleteCheckBox.setVisible(true);
         submitCheckBox.setSelected(false);
         submitCheckBox.setEnabled(false);
      }
      if (checkIn)
      {
         deleteCheckBox.setVisible(false);
         submitCheckBox.setVisible(false);
      }
   }

   /**
    * This method is called from within the constructor to initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
    */
   private void initComponents()
   { //GEN-BEGIN:initComponents
      IdeWindowManager idewindowmanager = IdeWindowManagerAccess.getWindowManager();
      deleteCheckBox = new JCheckBox();
      mainPanel = new JPanel();
      changesPanel = new JPanel();
      changeListPanel = new JPanel();
      changeListLabel = new JLabel();
      changeListComboBox = new JComboBox(changeNumbers);
      changeDescriptionPanel = new JPanel();
      descriptionTextArea = new JTextArea();
      descriptionScrollPane = new JScrollPane(descriptionTextArea);
      submitPanel = new JPanel();
      submitCheckBox = new JCheckBox();
      submitCheckBox.setSelected(true);
      submitCheckBox.setText("Auto Submit");
      submitCheckBox.setHorizontalTextPosition(SwingConstants.LEADING);
      buttonPanel = new JPanel();
      okButton = (JButton)idewindowmanager.setupStandardButton(null, "ok");
      cancelButton = (JButton)idewindowmanager.setupStandardButton(null, "cancel");
      setBackground(new Color(212, 208, 200));
      addWindowListener(
          new WindowAdapter()
          {
             public void windowClosing(WindowEvent evt)
             {
                closeDialog(evt);
             }
          });
      mainPanel.setLayout(new BorderLayout());
      changesPanel.setLayout(new BorderLayout());
      changeListPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
      changeListLabel.setText("Changelist Number");
      changeListLabel.setForeground(Color.black);
      changeListLabel.setFont(new Font("Arial", 0, 11));
      changeListPanel.add(changeListLabel);
      changeListComboBox.setFont(new Font("Dialog", 0, 11));
      changeListComboBox.setRenderer(new ChangeRenderer());
      changeListComboBox.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                changeListComboBoxActionPerformed(evt);
             }
          });
      changeListPanel.add(changeListComboBox);
      changesPanel.add(changeListPanel, BorderLayout.NORTH);
      changeDescriptionPanel.setLayout(new BorderLayout());
	  descriptionScrollPane.setSize(new Dimension(400, 160));
      descriptionScrollPane.setPreferredSize(new Dimension(400, 160));
      descriptionScrollPane.setMinimumSize(new Dimension(400, 160));
      descriptionScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      changeDescriptionPanel.add(descriptionScrollPane, BorderLayout.CENTER);
      changesPanel.add(changeDescriptionPanel, BorderLayout.SOUTH);
      Change change = (Change)changeListComboBox.getSelectedItem();
      String description = change.getDescription();
      char remove = '\t';
      description = removeChar(description, remove);
      descriptionTextArea.setText(description);
      descriptionTextArea.setEditable(true);
      descriptionTextArea.setCaretPosition(1);
      mainPanel.add(changesPanel, BorderLayout.NORTH);
      submitPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
      submitPanel.add(submitCheckBox);
      submitPanel.add(deleteCheckBox);
      mainPanel.add(submitPanel, BorderLayout.CENTER);
      okButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                okButtonActionPerformed(evt);
             }
          });
      cancelButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                cancelButtonActionPerformed(evt);
             }
          });
      IdeDialogButtonGroup idedialogbuttongroup = IdeWindowManagerAccess.getWindowManager().createButtonGroup();
      idedialogbuttongroup.add(okButton);
      idedialogbuttongroup.add(cancelButton);
      buttonPanel.add(okButton);
      buttonPanel.add(cancelButton);
      mainPanel.add(buttonPanel, BorderLayout.SOUTH);
      getContentPane().add(mainPanel, BorderLayout.CENTER);
      Dimension dimension = getContentPane().getSize();
      Dimension dimension1 = Toolkit.getDefaultToolkit().getScreenSize();
      setLocation((dimension1.width - dimension.width) / 2, (dimension1.height - dimension.height) / 2);
      setTitle("Select Changelist Number");
      deleteCheckBox.setHorizontalTextPosition(SwingConstants.LEADING);
      deleteCheckBox.setFont(new Font("Dialog", Font.PLAIN, 11));
      deleteCheckBox.setText("Open for Delete");
      deleteCheckBox.setAlignmentX(50.0f);
      deleteCheckBox.setMargin(new Insets(2, 50, 2, 2));
      deleteCheckBox.setHorizontalAlignment(SwingConstants.TRAILING);
      deleteCheckBox.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                deleteCheckBoxActionPerformed(evt);
             }
          });
      deleteCheckBox.setVisible(false);
      pack();
   } //GEN-END:initComponents

   private void changeListComboBoxActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_changeListComboBoxActionPerformed
      JComboBox cbox = (JComboBox)evt.getSource();
      Change change = (Change)cbox.getSelectedItem();
      String description = change.getDescription();
      char remove = '\t';
      description = removeChar(description, remove);
      descriptionTextArea.setText(description);
      descriptionTextArea.setCaretPosition(1);
      changeNumber = change.getNumber();
   } //GEN-LAST:event_changeListComboBoxActionPerformed

   private void okButtonActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_okButtonActionPerformed
      isOK = true;
      autoSubmit = this.submitCheckBox.isSelected();
      Change change = (Change)changeListComboBox.getSelectedItem();
      changeDescription = descriptionTextArea.getText();
      openForDelete = this.deleteCheckBox.isSelected();
      setVisible(false);
      dispose();
   } //GEN-LAST:event_okButtonActionPerformed

   private void cancelButtonActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_cancelButtonActionPerformed
      isOK = false;
      setVisible(false);
      dispose();
   } //GEN-LAST:event_cancelButtonActionPerformed

   private void deleteCheckBoxActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_okButtonActionPerformed
      if (deleteCheckBox.isSelected())
      {
         submitCheckBox.setEnabled(true);
      }
      else
      {
         submitCheckBox.setEnabled(false);
         submitCheckBox.setSelected(false);
      }
   }

   /** Closes the dialog */
   private void closeDialog(WindowEvent evt)
   { //GEN-FIRST:event_closeDialog
      setVisible(false);
      dispose();
   } //GEN-LAST:event_closeDialog

   /**
    * Removes a character from a String
    * @param orig The string to parse.
    * @param x The char to remove
    * @return The string with the char removed
    */
   public static String removeChar(String orig, char x)
   {
      StringBuffer retcode = new StringBuffer(orig.length());
      for (int i = 0; i < orig.length(); i++)
      {
         if (orig.charAt(i) != x)
            retcode.append(orig.charAt(i));
      }
      return retcode.toString();
   }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private JPanel mainPanel;
   private JPanel changesPanel;
   private JPanel changeListPanel;
   private JLabel changeListLabel;
   private JComboBox changeListComboBox;
   private JPanel changeDescriptionPanel;
   private JScrollPane descriptionScrollPane;
   private JTextArea descriptionTextArea;
   private JPanel submitPanel;
   private JCheckBox submitCheckBox;
   private JPanel buttonPanel;
   private JButton okButton;
   private JButton cancelButton;
   private ComboBoxModel changeNumbers;
   private JCheckBox deleteCheckBox;

   // End of variables declaration//GEN-END:variables
   public boolean isOK()
   {
      return isOK;
   }

   public boolean isAutoSubmit()
   {
      return autoSubmit;
   }

   public int getChangeNumber()
   {
      return changeNumber;
   }

   public String getChangeDescription()
   {
      return changeDescription;
   }

   public boolean isOpenForDelete()
   {
      return openForDelete;
   }
}
